#!/bin/sh

# VNC REMOTE

STUDENT_IP=$1
VIEWERARGS=$2
TEACHER_IP=`echo $DISPLAY | cut -f1 -d":"`
SSH=/usr/bin/ssh
X11VNC=/usr/bin/x11vnc
VNCVIEWER=/usr/X11R6/bin/vncviewer
SCALE=9/10
VNCLOG=/tmp/vnc.log

# Start a listening x11vnc process on the student's terminal
EXPECTED_STRING="The VNC desktop is"

c1="killall $X11VNC"
c2="export XAUTHORITY=/tmp/.Xauthority"
c3="export DISPLAY=:0"
c4="$X11VNC -scale $SCALE -allow $TEACHER_IP > $VNCLOG 2>&1 & "
c5="for i in 1 2 3 4 5 ; do sleep 1 "
c6="X=\`cat $VNCLOG | grep -m 1 \"$EXPECTED_STRING\"\`"
c7="if [ \"x\$X\" != \"x\" ] ; then echo \"SUCCESS\" ; break ; fi"
c8="done"

cmd="$c1;$c2;$c3;$c4 $c5;$c6;$c7;$c8"
RET=`$SSH root@$STUDENT_IP -i ~/.localapps/$USER-key "$cmd"`


# Launch a vncviewer connection to the student's x11vnc on the teacher's terminal
if [ "$RET" == "SUCCESS" ] ; then

cmd="export DISPLAY=:0; $VNCVIEWER $VIEWERARGS $STUDENT_IP:0 > /dev/null 2>&1 ; echo \"SUCCESS\""
$SSH root@$TEACHER_IP -i ~/.localapps/$USER-key "$cmd"

fi

